##############################
#
# COPYRIGHT (c) 2007 shagon
# COMPILER:PythonWin
# DEBUG ON Series 60 C++ SDKs
# TESTED ON NOKIA6670
# DONE:Sep 25th,2007
# UPDATE:Sep 26th,2007
#
##############################
# -*- coding:utf-8 -*- 
import appuifw
import e32
import os
import audio
from key_codes import *
appuifw.note('shagon作品\nwww.cnpda.com.cn\nCNPDA编程组\n2007.09.25'.decode("utf-8"), "info")
filename='e:\\Sounds\\NoteRecord\\record.wav'
currentfile='record.wav'
def exit():
    global running
    if appuifw.query('确认退出'.decode('utf8'),'query'):
        running=0
        appuifw.app.set_exit()
    else:
        appuifw.app.body=canvas
        canvas.clear()
        canvas.text((33,52),u'+==================+',0x000000)
        canvas.text((35,62),u'|',0x000000)
        canvas.text((54,64),u'------------',0x000000)
        canvas.text((131,62),u'|',0x000000)
        canvas.text((35,74),u'|',0x000000)
        canvas.text((131,74),u'|',0x000000)
        canvas.text((48,74),u'(   )',0x000000)
        canvas.text((100,74),u'(   )',0x000000)
        canvas.text((35,86),u'|',0x000000)
        canvas.text((131,86),u'|',0x000000)
        canvas.text((54,83),u'------------',0x000000)
        canvas.text((35,90),u'|',0x000000)
        canvas.text((131,90),u'|',0x000000)
        canvas.text((33,99),u'+---/-o------o-\---+',0x000000)
        canvas.text((57,92),u'~~~~~~~~~',0x000000)
        canvas.text((73,116),u'STOP',0x000000)
        canvas.text((42,25),u'shagon presents',0xf3a352)
        canvas.text((25,135),u'1',0xff0000)
        canvas.text((31,135),u'-Record',0x000000)
        canvas.text((100,135),u'P l a y-',0x000000)
        canvas.text((134,135),u' 3',0xff0000)
        canvas.text((72,153),u'5',0xff0000)
        canvas.text((78,153),u'top',0x000000)
        canvas.text((25,165),u'7',0xff0000)
        canvas.text((30,165),u'- N e w',0x000000)
        canvas.text((134,165),u' 9',0xff0000)
        canvas.text((100,165),u'Delete-',0x000000)
        canvas.text((72,178),u'0',0xff0000)
        canvas.text((78,178),u'pen',0x000000)
        canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
appuifw.app.exit_key_handler=exit
class Keyboard(object):
    def __init__(self,onevent=lambda:None):
        self._keyboard_state={}
        self._downs={}
        self._onevent=onevent
    def handle_event(self,event):
        if event['type'] == appuifw.EEventKeyDown:
            code=event['scancode']
            if not self.is_down(code):
                self._downs[code]=self._downs.get(code,0)+1
            self._keyboard_state[code]=1
        elif event['type'] == appuifw.EEventKeyUp:
            self._keyboard_state[event['scancode']]=0
        self._onevent()
    def is_down(self,scancode):
        return self._keyboard_state.get(scancode,0)
    def pressed(self,scancode):
        if self._downs.get(scancode,0):
            self._downs[scancode]-=1
            return True
        return False
keyboard=Keyboard()
running=1
appuifw.app.screen='full'
canvas=appuifw.Canvas(event_callback=keyboard.handle_event, redraw_callback=None)
appuifw.app.body=canvas
canvas.clear()
canvas.text((33,52),u'+==================+',0x000000)
canvas.text((35,62),u'|',0x000000)    
canvas.text((54,64),u'------------',0x000000)    
canvas.text((131,62),u'|',0x000000)    
canvas.text((35,74),u'|',0x000000)
canvas.text((131,74),u'|',0x000000)    
canvas.text((48,74),u'(   )',0x000000)    
canvas.text((100,74),u'(   )',0x000000)
canvas.text((35,86),u'|',0x000000)
canvas.text((131,86),u'|',0x000000)  
canvas.text((54,83),u'------------',0x000000)
canvas.text((35,90),u'|',0x000000)
canvas.text((131,90),u'|',0x000000)     
canvas.text((33,99),u'+---/-o------o-\---+',0x000000)    
canvas.text((57,92),u'~~~~~~~~~',0x000000)
canvas.text((73,116),u'STOP',0x000000)
canvas.text((42,25),u'shagon presents',0xf3a352)
canvas.text((25,135),u'1',0xff0000)
canvas.text((31,135),u'-Record',0x000000)
canvas.text((100,135),u'P l a y-',0x000000)
canvas.text((134,135),u' 3',0xff0000)
canvas.text((72,153),u'5',0xff0000)
canvas.text((78,153),u'top',0x000000)
canvas.text((25,165),u'7',0xff0000)
canvas.text((30,165),u'- N e w',0x000000)
canvas.text((134,165),u' 9',0xff0000)
canvas.text((100,165),u'Delete-',0x000000)
canvas.text((72,178),u'0',0xff0000)
canvas.text((78,178),u'pen',0x000000)
canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)

def easyrecord():
    global easy,filename
    easy=audio.Sound.open(filename)
    easy.record()
def easyplay():
    global easy,filename
    easy=audio.Sound.open(filename)
    if easy.state()==audio.EOpen:
        easy.play(1,0)
    else:
        appuifw.note('文件不存在'.decode("utf-8"),"error")        
def easystop():
    global easy,filename
    if easy.state()==audio.EOpen:
        easy.stop()
    easy.close()

while running:
    if keyboard.pressed(EScancode5):
        easystop()
        canvas.clear()
        canvas.text((33,52),u'+==================+',0x000000)
        canvas.text((35,62),u'|',0x000000)
        canvas.text((54,64),u'------------',0x000000)
        canvas.text((131,62),u'|',0x000000)
        canvas.text((35,74),u'|',0x000000)
        canvas.text((131,74),u'|',0x000000)
        canvas.text((48,74),u'(   )',0x000000)
        canvas.text((100,74),u'(   )',0x000000)
        canvas.text((35,86),u'|',0x000000)
        canvas.text((131,86),u'|',0x000000)
        canvas.text((54,83),u'------------',0x000000)
        canvas.text((35,90),u'|',0x000000)
        canvas.text((131,90),u'|',0x000000)
        canvas.text((33,99),u'+---/-o------o-\---+',0x000000)
        canvas.text((57,92),u'~~~~~~~~~',0x000000)
        canvas.text((73,116),u'STOP',0x000000)
        canvas.text((42,25),u'shagon presents',0xf3a352)
        canvas.text((25,135),u'1',0xff0000)
        canvas.text((31,135),u'-Record',0x000000)
        canvas.text((100,135),u'P l a y-',0x000000)
        canvas.text((134,135),u' 3',0xff0000)
        canvas.text((72,153),u'5',0xff0000)
        canvas.text((78,153),u'top',0x000000)
        canvas.text((25,165),u'7',0xff0000)
        canvas.text((30,165),u'- N e w',0x000000)
        canvas.text((134,165),u' 9',0xff0000)
        canvas.text((100,165),u'Delete-',0x000000)
        canvas.text((72,178),u'0',0xff0000)
        canvas.text((78,178),u'pen',0x000000)
        canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
    if keyboard.pressed(EScancode1):
        easyrecord()
        canvas.clear()
        canvas.text((33,52),u'+==================+',0xff0000)
        canvas.text((35,62),u'|',0xff0000)
        canvas.text((54,64),u'------------',0xff0000)
        canvas.text((131,62),u'|',0xff0000)
        canvas.text((35,74),u'|',0xff0000)
        canvas.text((131,74),u'|',0xff0000)
        canvas.text((48,74),u'(   )',0xff0000)
        canvas.text((100,74),u'(   )',0xff0000)
        canvas.text((35,86),u'|',0xff0000)
        canvas.text((131,86),u'|',0xff0000)
        canvas.text((54,83),u'------------',0xff0000)
        canvas.text((35,90),u'|',0xff0000)
        canvas.text((131,90),u'|',0xff0000)
        canvas.text((33,99),u'+---/-o------o-\---+',0xff0000)
        canvas.text((57,92),u'~~~~~~~~~',0xff0000)
        canvas.text((67,116),u'RECORD',0xff0000)
        canvas.text((42,25),u'shagon presents',0xf3a352)
        canvas.text((25,135),u'1',0xff0000)
        canvas.text((31,135),u'-Record',0x000000)
        canvas.text((100,135),u'P l a y-',0x000000)
        canvas.text((134,135),u' 3',0xff0000)
        canvas.text((72,153),u'5',0xff0000)
        canvas.text((78,153),u'top',0x000000)
        canvas.text((25,165),u'7',0xff0000)
        canvas.text((30,165),u'- N e w',0x000000)
        canvas.text((134,165),u' 9',0xff0000)
        canvas.text((100,165),u'Delete-',0x000000)
        canvas.text((72,178),u'0',0xff0000)
        canvas.text((78,178),u'pen',0x000000)
        canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
    if keyboard.pressed(EScancode3):
        easyplay()
        canvas.clear()
        canvas.text((33,52),u'+==================+',0x0000ff)
        canvas.text((35,62),u'|',0x0000ff)
        canvas.text((54,64),u'------------',0x0000ff)
        canvas.text((131,62),u'|',0x0000ff)
        canvas.text((35,74),u'|',0x0000ff)
        canvas.text((131,74),u'|',0x0000ff)
        canvas.text((48,74),u'(   )',0x0000ff)
        canvas.text((100,74),u'(   )',0x0000ff)
        canvas.text((35,86),u'|',0x0000ff)
        canvas.text((131,86),u'|',0x0000ff)
        canvas.text((54,83),u'------------',0x0000ff)
        canvas.text((35,90),u'|',0x0000ff)
        canvas.text((131,90),u'|',0x0000ff)
        canvas.text((33,99),u'+---/-o------o-\---+',0x0000ff)
        canvas.text((57,92),u'~~~~~~~~~',0x0000ff)
        canvas.text((73,116),u'PLAY',0x0000ff)
        canvas.text((42,25),u'shagon presents',0xf3a352)
        canvas.text((25,135),u'1',0xff0000)
        canvas.text((31,135),u'-Record',0x000000)
        canvas.text((100,135),u'P l a y-',0x000000)
        canvas.text((134,135),u' 3',0xff0000)
        canvas.text((72,153),u'5',0xff0000)
        canvas.text((78,153),u'top',0x000000)
        canvas.text((25,165),u'7',0xff0000)
        canvas.text((30,165),u'- N e w',0x000000)
        canvas.text((134,165),u' 9',0xff0000)
        canvas.text((100,165),u'Delete-',0x000000)
        canvas.text((72,178),u'0',0xff0000)
        canvas.text((78,178),u'pen',0x000000)
        canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
    if keyboard.pressed(EScancode7):        
        thefile=appuifw.query('E:\\Sounds\\NoteRecord\\*.wav\n输入新建文件名\n（不支持中文）'.decode("utf-8"),"text")
        if thefile<>None:
            currentfile=str(thefile)+'.wav'
            filename='e:\\Sounds\\NoteRecord\\'+currentfile
            appuifw.app.body=canvas
            canvas.clear()
            canvas.text((33,52),u'+==================+',0x000000)
            canvas.text((35,62),u'|',0x000000)
            canvas.text((131,62),u'|',0x000000)
            canvas.text((35,74),u'|',0x000000)
            canvas.text((131,74),u'|',0x000000)
            canvas.text((35,86),u'|',0x000000)
            canvas.text((131,86),u'|',0x000000)
            canvas.text((35,90),u'|',0x000000)
            canvas.text((131,90),u'|',0x000000)
            canvas.text((33,99),u'+------------------+',0x000000)
            canvas.text((76,116),u'NEW',0x000000)
            canvas.text((42,25),u'shagon presents',0xf3a352)
            canvas.text((25,135),u'1',0xff0000)
            canvas.text((31,135),u'-Record',0x000000)
            canvas.text((100,135),u'P l a y-',0x000000)
            canvas.text((134,135),u' 3',0xff0000)
            canvas.text((72,153),u'5',0xff0000)
            canvas.text((78,153),u'top',0x000000)
            canvas.text((25,165),u'7',0xff0000)
            canvas.text((30,165),u'- N e w',0x000000)
            canvas.text((134,165),u' 9',0xff0000)
            canvas.text((100,165),u'Delete-',0x000000)
            canvas.text((72,178),u'0',0xff0000)
            canvas.text((78,178),u'pen',0x000000)
            canvas.text((84,90),u'O',0x000000)
            canvas.text((76,78),u'O  O',0x000000)
            canvas.text((96,66),u'O',0x000000)
            canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
        else:
            appuifw.app.body=canvas
            canvas.clear()
            canvas.text((33,52),u'+==================+',0x000000)
            canvas.text((35,62),u'|',0x000000)
            canvas.text((54,64),u'------------',0x000000)
            canvas.text((131,62),u'|',0x000000)
            canvas.text((35,74),u'|',0x000000)
            canvas.text((131,74),u'|',0x000000)
            canvas.text((48,74),u'(   )',0x000000)
            canvas.text((100,74),u'(   )',0x000000)
            canvas.text((35,86),u'|',0x000000)
            canvas.text((131,86),u'|',0x000000)
            canvas.text((54,83),u'------------',0x000000)
            canvas.text((35,90),u'|',0x000000)
            canvas.text((131,90),u'|',0x000000)
            canvas.text((33,99),u'+---/-o------o-\---+',0x000000)
            canvas.text((57,92),u'~~~~~~~~~',0x000000)
            canvas.text((59,116),u'CANCELLED',0x000000)
            canvas.text((42,25),u'shagon presents',0xf3a352)
            canvas.text((25,135),u'1',0xff0000)
            canvas.text((31,135),u'-Record',0x000000)
            canvas.text((100,135),u'P l a y-',0x000000)
            canvas.text((134,135),u' 3',0xff0000)
            canvas.text((72,153),u'5',0xff0000)
            canvas.text((78,153),u'top',0x000000)
            canvas.text((25,165),u'7',0xff0000)
            canvas.text((30,165),u'- N e w',0x000000)
            canvas.text((134,165),u' 9',0xff0000)
            canvas.text((100,165),u'Delete-',0x000000)
            canvas.text((72,178),u'0',0xff0000)
            canvas.text((78,178),u'pen',0x000000)
            canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
    if keyboard.pressed(EScancode0):
        thefile=appuifw.query('E:\\Sounds\\NoteRecord\\*.wav\n输入读取文件名\n（不支持中文）'.decode("utf-8"),"text")
        if thefile<>None:
            currentfile=str(thefile)+'.wav'
            filename='e:\\Sounds\\NoteRecord\\'+currentfile
            appuifw.app.body=canvas
            canvas.clear()
            canvas.text((33,52),u'+==================+',0x000000)
            canvas.text((35,62),u'|',0x000000)
            canvas.text((54,64),u'------------',0x000000)
            canvas.text((131,62),u'|',0x000000)
            canvas.text((35,74),u'|',0x000000)
            canvas.text((131,74),u'|',0x000000)
            canvas.text((48,74),u'(   )',0x000000)
            canvas.text((100,74),u'(   )',0x000000)
            canvas.text((35,86),u'|',0x000000)
            canvas.text((131,86),u'|',0x000000)
            canvas.text((54,83),u'------------',0x000000)
            canvas.text((35,90),u'|',0x000000)
            canvas.text((131,90),u'|',0x000000)
            canvas.text((33,99),u'+---/-o------o-\---+',0x000000)
            canvas.text((57,92),u'~~~~~~~~~',0x000000)
            canvas.text((69,116),u'OPENED',0x000000)
            canvas.text((42,25),u'shagon presents',0xf3a352)
            canvas.text((25,135),u'1',0xff0000)
            canvas.text((31,135),u'-Record',0x000000)
            canvas.text((100,135),u'P l a y-',0x000000)
            canvas.text((134,135),u' 3',0xff0000)
            canvas.text((72,153),u'5',0xff0000)
            canvas.text((78,153),u'top',0x000000)
            canvas.text((25,165),u'7',0xff0000)
            canvas.text((30,165),u'- N e w',0x000000)
            canvas.text((134,165),u' 9',0xff0000)
            canvas.text((100,165),u'Delete-',0x000000)
            canvas.text((72,178),u'0',0xff0000)
            canvas.text((78,178),u'pen',0x000000)
            canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
        else:
            appuifw.app.body=canvas
            canvas.clear()
            canvas.text((33,52),u'+==================+',0x000000)
            canvas.text((35,62),u'|',0x000000)
            canvas.text((54,64),u'------------',0x000000)
            canvas.text((131,62),u'|',0x000000)
            canvas.text((35,74),u'|',0x000000)
            canvas.text((131,74),u'|',0x000000)
            canvas.text((48,74),u'(   )',0x000000)
            canvas.text((100,74),u'(   )',0x000000)
            canvas.text((35,86),u'|',0x000000)
            canvas.text((131,86),u'|',0x000000)
            canvas.text((54,83),u'------------',0x000000)
            canvas.text((35,90),u'|',0x000000)
            canvas.text((131,90),u'|',0x000000)
            canvas.text((33,99),u'+---/-o------o-\---+',0x000000)
            canvas.text((57,92),u'~~~~~~~~~',0x000000)
            canvas.text((59,116),u'CANCELLED',0x000000)
            canvas.text((42,25),u'shagon presents',0xf3a352)
            canvas.text((25,135),u'1',0xff0000)
            canvas.text((31,135),u'-Record',0x000000)
            canvas.text((100,135),u'P l a y-',0x000000)
            canvas.text((134,135),u' 3',0xff0000)
            canvas.text((72,153),u'5',0xff0000)
            canvas.text((78,153),u'top',0x000000)
            canvas.text((25,165),u'7',0xff0000)
            canvas.text((30,165),u'- N e w',0x000000)
            canvas.text((134,165),u' 9',0xff0000)
            canvas.text((100,165),u'Delete-',0x000000)
            canvas.text((72,178),u'0',0xff0000)
            canvas.text((78,178),u'pen',0x000000)
            canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
    if keyboard.pressed(EScancode9):
        os.remove(filename)
        currentfile='None'
        canvas.clear()
        canvas.text((33,52),u'+==================+',0x000000)
        canvas.text((35,62),u'|',0x000000)
        canvas.text((131,62),u'|',0x000000)
        canvas.text((35,74),u'|',0x000000)
        canvas.text((131,74),u'|',0x000000)
        canvas.text((35,86),u'|',0x000000)
        canvas.text((131,86),u'|',0x000000)
        canvas.text((35,90),u'|',0x000000)
        canvas.text((131,90),u'|',0x000000)
        canvas.text((33,99),u'+------------------+',0x000000)
        canvas.text((68,116),u'DELETED',0x000000)
        canvas.text((42,25),u'shagon presents',0xf3a352)
        canvas.text((25,135),u'1',0xff0000)
        canvas.text((31,135),u'-Record',0x000000)
        canvas.text((100,135),u'P l a y-',0x000000)
        canvas.text((134,135),u' 3',0xff0000)
        canvas.text((72,153),u'5',0xff0000)
        canvas.text((78,153),u'top',0x000000)
        canvas.text((25,165),u'7',0xff0000)
        canvas.text((30,165),u'- N e w',0x000000)
        canvas.text((134,165),u' 9',0xff0000)
        canvas.text((100,165),u'Delete-',0x000000)
        canvas.text((72,178),u'0',0xff0000)
        canvas.text((78,178),u'pen',0x000000)
        canvas.text((72,88),u'X    X',0x000000)
        canvas.text((72,68),u'X    X',0x000000)
        canvas.text((84,78),u'X',0x000000)
        canvas.text((25,196),u'>>>>'+unicode(currentfile),0x3648ed)
    e32.ao_yield()
app_lock = e32.Ao_lock()
app_lock.wait()